//---------------------------------------------------------------------------
#ifndef GlobalH
#define GlobalH
#include <ShlObj.h>
#include <vcl\comctrls.hpp>
//---------------------------------------------------------------------------
#define AppMainForm Application->MainForm
#define AppProcessMessages() Application->ProcessMessages();
const AnsiString AppExeName = Application->ExeName.UpperCase();
const AnsiString AppDir = ExtractFilePath(AppExeName).LowerCase();
//const AnsiString AppExe(QS.exe); -- is in version.h
const bool off = false;
const bool on = true;

#define s(s) AnsiString(s)
#define sm(m) ShowMessage(s(m))
#define MsgBoxHwnd(h,m,t,b) MessageBox(HWND(h),String(m).c_str(),String(t).c_str(),b)
#define MsgBox(m,t,b) MsgBoxHwnd(Application->MainForm->Handle,m,t,b)
#define CutMarks  GetAppIni("Cutmarks","~~")
#define QteMarks  GetAppIni("QteMarks","> ")
//#define MixUseExe GetAppIni("MixUseExe","1").ToIntDef(1)

#define WM_QUEUECHANGE    WM_USER+1
#define WM_PROBLEMCHANGE  WM_USER+2
#define WM_UPDATECHECKED  WM_USER+3
#define WM_UPDATEENABLE   WM_USER+4
#define WM_CHECKUPDATE    WM_USER+5
#define WM_SETBUTTONS     WM_USER+6
#define WM_GETERRORLOG    WM_USER+7
#define WM_OPENPROBLEMS   WM_USER+8
#define WM_OPENQUEUE      WM_USER+9
#define WM_LOADBOXMENU    WM_USER+10
#define WM_INSERTFILENAME WM_USER+11
#define WM_DISPLAYXY      WM_USER+12
#define WM_REFRESHINDEX	WM_USER+13
#define WM_INCOMINGMAIL   WM_USER+15
#define WM_OPENINBOX      WM_USER+16
#define WM_STOREPOPLOG    WM_USER+17
#define WM_SENDMAIL       WM_USER+18
#define WM_SETWINCURSOR   WM_USER+19
#define WM_SHOWSTATUS     WM_USER+21
#define WM_SAVEQUIT       WM_USER+22
#define WM_OPENADDRESSES  WM_USER+23
#define WM_OPENHELP       WM_USER+24
#define WM_EDITMENU       WM_USER+25
#define WM_GETBUTTONCLICK WM_USER+26
#define WM_HELPWINPOS     WM_USER+27
#define WM_OPENKEYMAN     WM_USER+28
#define WM_NEXTMESSAGE    WM_USER+100  // smtp
#define WM_NEXTPOP        WM_USER+101  // pop3
//===================================
#define WM_DATREQUEST     WM_USER+20
#define GetDatData           (WORD)1
#define PutDatData           (WORD)2
//===================================

//#define DEFNYMOPS AnsiString("+acksend -signsend +cryptrecv -fixedsize -disable -fingerkey -nobcc")
const AnsiString QSpop3Name("QSpop3.dll");
const AnsiString QSpgpName("QSpgp.dll");
const AnsiString HelpWinPos = "HelpWinPos";

const AnsiString QuickStart = "QuickStart.rtf";
const AnsiString QuickStartPop3 = "QuickStart.Pop3.rtf";
const AnsiString QuickStartPgp = "QuickStart.Pgp.rtf";

const AnsiString BugReportAddress = "quicksilver@skuz.net";
const bool UseDialog = true;

const AnsiString DatExt(".dbc");
const AnsiString PooExt(".dpc");
const AnsiString PgpExt(".pgp");
const AnsiString IniExt(".ini");
const AnsiString BakExt(".bak");
const AnsiString TmpExt(".tmp");
const AnsiString OrgExt(".org");

const AnsiString AppDat = ChangeFileExt(AppExeName,DatExt);

const AnsiString OriginalKey = "Originals";

const AnsiString AppIni = ChangeFileExt(AppExeName,IniExt);
const AnsiString AppPgp = ChangeFileExt(AppExeName,PgpExt);
const AnsiString AppPgpBak = AppPgp+BakExt;
const AnsiString AppPgpTmp = AppPgp+TmpExt;
const AnsiString IniUpdateOnSend = "UpdateOnSend";

//#define PS PATHSEPARATOR // in fileman.h
const AnsiString AppIniValues   = "Initialization";
const AnsiString UserNyms       = "Nyms";
const AnsiString UserNotes      = "Notes";
const AnsiString WasUserMessages= "Messages";
const AnsiString UserMessages   = "Drafts";
const AnsiString UserTemplates  = "Templates";
const AnsiString UserAddresses  = "Address Book";
const AnsiString UserMailboxes  = "Mailboxes";
const AnsiString UserData       = "User Data";
const AnsiString MailQueue      = "Mail Queue";
const AnsiString ProblemQueue   = "Problems Queue";
const AnsiString MailboxBoxmenu = "Mailbox Menu";    // boxes included on mailbox menu
const AnsiString MailboxPos     = "Mailbox Pos";  // position of cursor in box index
const AnsiString StatsURLs      = "StatsURLs";
const AnsiString HttpInfo       = "Http Info";
const AnsiString FtpProxy       = "Ftp Proxy";
const AnsiString UseFtpProxy    = "Use Ftp Proxy";
const AnsiString MixValues      = "Mixmaster";
const AnsiString PopAccounts    = "Pop Accounts";
const AnsiString PopLastMsgId   = "Last Message-ID";
const AnsiString UpdateSites    = "Update Sites";
const AnsiString StatsTimeOut   = "Stats Timeout";
const AnsiString Pop3TimeOut    = "Pop3 TimeOut";
const AnsiString ErrChkLog      = "ErrorChecksLog";
const AnsiString ErrChkLogMax   = "ErrChkLogMax";
const AnsiString POP3Log        = "Pop3Log";
const AnsiString POP3LogMax     = "Pop3LogMax";
const AnsiString SMTPLog        = "SmtpLog";
const AnsiString SMTPLogMax     = "SmtpLogMax";
const AnsiString ChainLog       = "ChainLog";
const AnsiString ChainLogMax    = "ChainLogMax";
const AnsiString CpunkShorts    = "CpunkShorts";
const AnsiString Cyberpunk      = "Cyberpunk";
const AnsiString CpkKeyUpdate   = "CpkKeyUpdate";
const AnsiString Mixmaster      = "Mixmaster";
const AnsiString MixKeyUpdate   = "MixKeyUpdate";
const AnsiString MixAutoChecked = "MixAuto";
const AnsiString CorruptReport  = "*****Corrupt Report*****";
const AnsiString StatsCopies    = "StatsKeepCopies";
const AnsiString StatsErrCheck  = "StatsErrorCheck";

const AnsiString PgpPubRing     = "PgpPublicRing";
const AnsiString PgpSecRing     = "PgpSecretRing";
const AnsiString PgpImpRing     = "PgpImportRing";
//const AnsiString PgpImportFile  = "";
const AnsiString PgpOriginals   = "Pgp Originals";

//const AnsiString TempBugReportFile = "QSTemplateBugReport.txt";
//const AnsiString BugReport       = "BugReport";

const AnsiString AppRandPool     = "RandomPool"; // MixValues+PS+AppRandPool
const AnsiString MixClientCfg    = "ClientCfg";

const AnsiString DatExePath      = "exe";
const AnsiString UnzipApp        = "unzipping.exe";

const AnsiString POP3YouGotMail  = "You got mail!";
const AnsiString POP3SorryNoMail = "Sorry, no new mail.";
const AnsiString POP3UserCancel  = "User cancel";
const AnsiString POP3ErrorAbort  = "Error: aborted!";

// statistics filenames (and datakeys)
const AnsiString MixImportDir = "MixImportDir"; // dir where qs looks for importing mix keys
const AnsiString CpkImportDir = "CpkImportDir"; // dir where qs looks for importing mix keys

const AnsiString MListTxt = "mlist.txt";
const AnsiString MRingTxt = "pubring.mix";
const AnsiString MProbTxt = "problem.mix";
const AnsiString MRingTmp =  MRingTxt+".tmp";
const AnsiString MTyp2Txt = "type2.list";

const AnsiString CListTxt = "rlist.txt";
const AnsiString CListTmp =  CListTxt+".tmp";
const AnsiString CRingTxt = "pubring.asc";
const AnsiString CRingTmp =  CRingTxt+".tmp";
const AnsiString CTyp1Txt = "type1.list";
const AnsiString CProbTxt = "problem.cpk";

const bool nosave = false;
const bool save = true;

#define mlisttxt MixDir()+MListTxt
#define mprobtxt MixDir()+MProbTxt
#define mringtxt MixDir()+MRingTxt
#define mtyp2txt MixDir()+MTyp2Txt

#define clisttxt MixDir()+CListTxt
#define clisttmp MixDir()+CListTmp
#define cprobtxt MixDir()+CProbTxt
#define cringtxt MixDir()+CRingTxt
#define cringtmp MixDir()+CRingTmp
#define ctyp1txt MixDir()+CTyp1Txt

#define STATSBAKCOPIES GetAppIni(StatsCopies,"").ToIntDef(3)

// used for def keyring names when importing pgp keys
const AnsiString PGPPubRing = AppDir+"pubring.pkr";
const AnsiString PGPSecRing = AppDir+"secring.skr";
const int SleepTime = 100;
const int DesignPixelsPerInch = 96;

const AnsiString WordWrapHeader = "Word-Wrap: ";
// preferences
const AnsiString QuoteMarks = "QteMarks";
const AnsiString StatsMinUpdates = "StatsMinUpdates";
const AnsiString WordWrap = "WordWrap";
const AnsiString WordWrapShowBox = "WordWrapShowBox";
const AnsiString DontWrapQuoted = "DontWrapQuoted";
const AnsiString SendWrapChars = "SendWrapChars";
const AnsiString SendWrapCharsCount = "SendWrapCharsCount";
const AnsiString SendWrapWin = "SendWrapWin";
const AnsiString SendWrapNot = "SendWrapNot";
const AnsiString EdFontName = "FontName";
const AnsiString EdFontSize = "FontSize";
const AnsiString WorkSpaceColor = "WorkSpaceColor";
const AnsiString ClearSignMessage = "ClearSignMessage";

// menu ID used by setup.exe, uninst.exe, for 'About...' on system menu
#define IDS_CUSTOMSYSMENUITEM 0x1000

void __fastcall SaveToFileNoWrap(TRichEdit *Editor, AnsiString &FileName);
void __fastcall GetUnWrappedText(TRichEdit *Editor, TStrings *ToStrings);
void __fastcall SetRedraw(TWinControl *window, bool set);
TColor __fastcall GetColor16(int Index);
void __fastcall ClearString(AnsiString &str);
AnsiString __fastcall GetLastErrorStr();
bool DiskInDrive(char drive);
bool __fastcall SetRunOnce(const AnsiString Name, const AnsiString RunCmd);
void __fastcall MyBeep(WORD BeepType=MB_OK);
bool __fastcall DeleteDirectory(AnsiString &pathname);
HINSTANCE __fastcall ExploreFolder(AnsiString &strFolder);
HANDLE __fastcall Exec95(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
DWORD __fastcall ExecAndWait95(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
AnsiString __fastcall GetShortFileName(AnsiString &FileName);
AnsiString __fastcall GetWindowsDir();
AnsiString __fastcall GetTempDir();
void __fastcall PasteFromClipboard(TRichEdit *Editor);
void __fastcall CenterDialog(TForm *CenteredForm, TForm *MainForm=Application->MainForm);
AnsiString __fastcall GetToken(int pos, AnsiString &fromBuf, char *divider, char *def="");
AnsiString __fastcall GetParam(int pos, AnsiString &fromBuf, char *divider=",", char *def="");
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr);
int __fastcall GetFilenames(TStrings *names, AnsiString &pathname, int attrib=faAnyFile);
AnsiString __fastcall AddBackslash(AnsiString path);
AnsiString __fastcall RemoveBackslash(AnsiString path);
HRESULT CreateLink(AnsiString TargetPath, AnsiString LinkPath, AnsiString IconPath,
   AnsiString Description, AnsiString Params);
bool __fastcall RegKeyExists(AnsiString &Key);
void __fastcall BufSaveToFileBak(byte* buffer, int length, AnsiString &docname, int bakcopies);
void __fastcall SaveToFileBak(TStrings *Document, AnsiString &FileName, int bakcopies);
void __fastcall FileSaveToFileBak(AnsiString &TmpFile, AnsiString &FileName, int bakcopies);
AnsiString __fastcall bak(AnsiString &name, int baknumber);

extern bool DoMyBeep;
//---------------------------------------------------------------------------
#endif
