//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyImptDlgs.h"
#include "MixProbWins.h"
#include "Mixmaster.h"
#include "Global.h"
#include "HelpDlgs.h"
#include "View.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMixKeyImptDlg *MixKeyImptDlg;
const AnsiString MixNoKeysFoundAtAll = "...NO KEYS FOUND AT ALL!";
const AnsiString MixLoading = "Loading...";
//---------------------------------------------------------------------------
bool __fastcall ImportMixmasterKeys(TForm *Owner, TMixKeyList *keylist,
   TMixKeyList *ImpKeys, TMixKeyList *DupKeys,AnsiString &ImportDir)
{
   MixKeyImptDlg = new TMixKeyImptDlg(Owner,keylist,ImpKeys,DupKeys,ImportDir);
   MixKeyImptDlg->ShowModal();
   bool ok = MixKeyImptDlg->ModalResult==mrOk &&
      (ImpKeys->Count || DupKeys->Count);
   delete MixKeyImptDlg;
   return ok;
}
//---------------------------------------------------------------------------
/*procedure THETreeView.SetItemBold(ANode: TTreeNode; Value: Boolean);
var
  Item: TTVItem;
  Template: Integer;
begin
  if ANode = nil then Exit;

  if Value then Template := -1
  else Template := 0;
  with Item do
  begin
    mask := TVIF_STATE;
    hItem := ANode.ItemId;
    stateMask := TVIS_BOLD;
    state := stateMask and Template;
  end;
  TreeView_SetItem(Handle, Item);
end;*/
//---------------------------------------------------------------------------
__fastcall TMixKeyImptDlg::TMixKeyImptDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyImptDlg::TMixKeyImptDlg(TComponent* Owner, TMixKeyList *Keylist,
   TMixKeyList *ImpKeys, TMixKeyList *DupKeys, AnsiString &ImportDir)
   : TForm(Owner)
{
   CenterDialog(this);
   impdir = &ImportDir;
   OpenDialog->InitialDir = *impdir;
   OpenDialog->Filter = "Mixmaster key files (*.mix)|*.mix|All files (*.*)|*.*";
   OpenDialog->DefaultExt = ".mix";
   OpenDialog->FileName = "*.mix";
   ComboBox1->Items->Text = "Import Keys to Pubring.mix";
   ComboBox1->ItemIndex = 0;
   keylist = Keylist;
   implist = ImpKeys;
   implist->Clear();
   duplist = DupKeys;
   duplist->Clear();
   dislist = new TMixKeyList();
   cap = Caption;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyImptDlg::~TMixKeyImptDlg()
{
   delete dislist;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::FileBtnClick(TObject *Sender)
{
   if (OpenDialog->Execute())
   {
      flash=0; Timer1->Enabled = true;
      TStringList *keys = new TStringList();
      keys->LoadFromFile(OpenDialog->FileName);
      ImportKeys(ExtractFileName(OpenDialog->FileName),keys->Text);
      Timer1->Enabled = false;
      delete keys;

     *impdir = ExtractFilePath(OpenDialog->FileName);
      OpenDialog->InitialDir = *impdir;
      ActiveControl = Panel1;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::ClipBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Import keys from the clipboard?","Confirm",MB_OKCANCEL)==IDOK)
   {
      flash=0; Timer1->Enabled = true;
      TStringList *clip = new TStringList();
      clip->Text = MixPasteFromClipboard();
      ImportKeys("Clipboard",clip->Text);
      Timer1->Enabled = false;

      if (RichEdit1->Lines->Count &&
          RichEdit1->Lines->Strings[0].Pos(MixNoKeysFoundAtAll)>0)
      {
         RichEdit1->Lines->Add("");
         RichEdit1->Lines->Add("");
         RichEdit1->Lines->Add("---Clipboard Contents---------------------");
         RichEdit1->Lines->AddStrings(clip);
      }
      delete clip;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::ImportKeys(AnsiString Name, AnsiString Ascii)
{
   implist->Clear();
   duplist->Clear();
   dislist->Clear();
   RichEdit1->Clear();
   TrashBtn->Enabled = false;
   Caption = "";//MixLoading;

   int newcnt=0,dupcnt=0,discnt=0;
   AnsiString s,mshort,curdesc,desc,keytext,orglines=Ascii;
   TStringList *key = new TStringList();
   TStringList *keys = new TStringList();
   ImportBtn->Enabled = false;
   keys->Text = Ascii;

   SetRedraw(Panel1,0);
   TMixKeyList *probs = new TMixKeyList(mprobtxt);
   while (MixGetNextKey(desc,key,keys)) // in mixmaster.cpp
   {
      bool dis=false,dup=false;
      // is the key already in type2
      if (keylist->IndexOf(desc)>=0 || probs->IndexOf(desc)>=0)
      {
         dislist->AddKey(desc,key);
         dis = true;
         discnt++;
      }
      // No? Is the remailer shortname in type2
      if (!dis)
      {
         mshort = GetToken(0,desc," ");
         for (int i=0; i<keylist->Count; i++)
         {
            if (mshort==GetToken(0,keylist->Strings[i]," "))
            {
               duplist->AddKey(desc,key);
               dup = true;
               dupcnt++;
               break;
            }
         }
      }
      // if neither above this is a new key
      if (!dis && !dup)
      {
         implist->AddKey(desc,key);
         newcnt++;
      }
   }
   delete probs;

   while (flash<4) AppProcessMessages();
   Timer1->Enabled = false;

   if (newcnt)
   {
      RichEdit1->Lines->Add(Name+"..."+s(newcnt)+" NEW KEY"+s.UpperCase());
      for (int i=0; i<newcnt; i++)
         RichEdit1->Lines->Add(" "+implist->Strings[i]);
   }
   else
   {
      if (dupcnt || discnt) RichEdit1->Lines->Add(Name+"...NO NEW KEYS");
      else RichEdit1->Lines->Add(Name+MixNoKeysFoundAtAll);
   }
   // duplicates
   if (dupcnt)
   {
      // new style
      RichEdit1->Lines->Add(Name+"..."+s(dupcnt)+" DUPLICATE KEY"+s.UpperCase());
      for (int i=0; i<dupcnt; i++)
         RichEdit1->Lines->Add(" "+duplist->Strings[i]);
   }
   if (!newcnt && !dupcnt) RichEdit1->Lines->Add(Name+"...DONE");
   else
   {
      RichEdit1->Lines->Add(Name+"...OK");
      ImportBtn->Enabled = true;
   }

   AppProcessMessages();
   SetRedraw(Panel1,1);
   Caption = cap;
   delete keys;
   delete key;
   MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::Timer1Timer(TObject *Sender)
{
   if (Caption.IsEmpty()) Caption = MixLoading;
   else Caption = "";
   flash++;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel)
   {
      if (ImportBtn->Enabled)
      {
          switch (MsgBoxHwnd(Handle,
            "You have good new keys!  Save them now?","Confirm",MB_YESNOCANCEL))
          {
             case IDCANCEL: CanClose=false; return;
             case IDNO: return;
          }
      }
      else return;
   }

   if (ImportBtn->Enabled)
   {
      Caption = "Importing...";
      ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::TrashBtnClick(TObject *Sender)
{
   /*int item = KeyList->ItemIndex; if (item<1) return;
   if (MsgBoxHwnd(Handle,
      "Delete key for '"+GetParam(0,KeyList->Items->Strings[item]," ")+"' remailer?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
     delete dynamic_cast<TStringList*>(KeyList->Items->Objects[item]);
     KeyList->Items->Delete(item);
     TrashBtn->Enabled = false;
     ActiveControl = Panel1;
   }*/
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::PopDeleteItemClick(TObject *Sender)
{
   PopDeleteItem->Enabled = TrashBtn->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyImptDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("MixmasterKeysImp","Mixmaster Keys","");
}
//---------------------------------------------------------------------------
