//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyWins.h"
#include "MixKeyImptDlgs.h"
#include "MixProbWins.h"
#include "MainMDI.h"
#include "Mixmaster.h"
#include "HelpDlgs.h"
#include "HeadMan.h"
#include "FileMan.h"
#include "FileWin.h"
#include "pgpmail.h"
#include "ClipReply.h"
#include "Global.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TMixKeyWin *MixKeyWin=NULL;
//---------------------------------------------------------------------------
// TMixKeyList
//---------------------------------------------------------------------------
__fastcall TMixKeyList::TMixKeyList()
   : TStringList()
{
   newkeys = new TStringList();
   Sorted = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList::TMixKeyList(AnsiString FileName)
   : TStringList()
{
   newkeys = new TStringList();
   Sorted = true;
   LoadFromFile(FileName);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList::TMixKeyList(TStrings *keyblocks)
  : TStringList()
{
   newkeys = new TStringList();
   Sorted = true;
   LoadFromStrings(keyblocks);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList::~TMixKeyList()
{
   delete newkeys;
   Clear();
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList::AddAscii(TStrings *ascii)
{
   if (MixKeyDefinately(ascii)) // in mixmaster.cpp
      return AddKey(CrtDesc(ascii->Strings[0]),ascii);
   return -1;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList::GetNextKey(AnsiString &keydesc, TStrings *key,
   TStrings *keys)
{
   return MixGetNextKey(keydesc,key,keys);
}
//---------------------------------------------------------------------------
void __fastcall SetTreeItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::GenTreeView(TTreeView *TreeView, TStrings *type2,
   TList *keys)
{
   keys->Clear();
   SetRedraw(TreeView,0);
   TTreeNode *node,*cnode;
   TreeView->Items->Clear();
   MixGenType2(type2,this,nosave);

   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<Count; i++)
   {
      AnsiString keydesc = Strings[i];
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,
         dynamic_cast<TStrings*>(Objects[i]));

      node->ImageIndex = EnabledDesc(keydesc,type2) ? 0:1;
      node->SelectedIndex = node->ImageIndex;
      if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);
      keys->Add(node);

      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   delete next;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList::CrtDesc(int atPos)
{
   return CrtDesc(KeyDesc(atPos));
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList::CrtDesc(AnsiString keydesc)
{
   if (keydesc.Pos("  ")>0) return keydesc;
   AnsiString shrt,rest;
   shrt = GetToken(0,keydesc," ").LowerCase();
   rest = keydesc.SubString(shrt.Length()+1,256).Trim(); shrt += "            ";
   int len=10; if (shrt.SubString(1,1)=="#") len = 11;
   return shrt.SubString(1,len)+" "+rest;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList::KeyShort(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetToken(0,Strings[atPos]," ");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList::KeyDesc(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   TStrings *key=dynamic_cast<TStrings*>(Objects[atPos]);
   if (key && key->Count) return key->Strings[0];
   return "";
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::Clear()
{
   for (int i=0; i<Count; i++)
      delete dynamic_cast<TStringList*>(Objects[i]);
   TStringList::Clear();
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList::KeyDescExists(AnsiString &keydesc)
{
   bool exist=false;
   for (int i=0; i<Count; i++)
   {
      if (Strings[i]==keydesc)
      {
         exist = true;
         break;
      }
   }
   return exist;
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList::AddKey(AnsiString &keydesc, TStrings* keyblock)
{
   TStringList *key = new TStringList();
   key->AddStrings(keyblock);
   return AddObject(keydesc,key);
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList::AddKeys(TMixKeyList *keys)
{
   int c=0;
   TStrings *block;
   AnsiString keydesc;
   for (int i=0; i<keys->Count; i++)
   {
      keydesc = keys->CrtDesc(i); //keys->Strings[i];
      if (!KeyDescExists(keydesc) &&
          (block=dynamic_cast<TStrings*>(keys->Objects[i]))!=NULL)
      {
         AddKey(keydesc,block);
         c++;
      }
   }
   return c;
}
//---------------------------------------------------------------------------
//int __fastcall TMixKeyList::AddKeysImport(TMixKeyList *Newkeys)
//{
//   newkeys->Clear();
//   newkeys->AddStrings(Newkeys);
//   return AddKeys(Newkeys);
//}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList::ImportAscii(AnsiString AsciiStr)
{
   TStringList *ascii = new TStringList();
   ascii->Text = AsciiStr;
   return AddAscii(ascii);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList::ExportAscii(int atPos)
{
   AnsiString ascii;
   if (atPos<0 || atPos>=Count) return "";
   TStrings *keyblock = dynamic_cast<TStrings*>(Objects[atPos]);
   if (keyblock) ascii = keyblock->Text;
   return ascii;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::SaveToStrings(TStrings *strings)
{
   strings->Clear();
   for (int i=0; i<Count; i++)
   {
      strings->AddStrings(dynamic_cast<TStringList*>(Objects[i]));
      strings->Add("");
   }
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList::IndexOf(AnsiString Remailer)
{
   int idx=-1;
   for (int i=0; i<Count; i++)
   {
      if (Remailer==Strings[i])
      {
         idx = i;
         break;
      }
   }
   return idx;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::LoadFromStrings(TStrings *Strings)
{
   Clear();
   AnsiString keydesc;
   TStringList *key=new TStringList();
   TStringList *keys=new TStringList();
   keys->AddStrings(Strings);
   while (GetNextKey(keydesc,key,keys))
   {
//view(key); // uncomment to see each key field and ascii block
      if (KeyDescExists(keydesc) || keydesc.Pos(NoNameYet)==1) continue;
      AddKey(keydesc,key);
   }
   delete keys;
   delete key;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::LoadFromFile(AnsiString FileName)
{
   Filename = FileName;
   TStringList *keys = new TStringList();
   if (FileExists(Filename)) keys->LoadFromFile(Filename);
   LoadFromStrings(keys);
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::Save(int bakcopies)
{
   SaveToFileBak(Filename,bakcopies);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::SaveToFile(AnsiString FileName)
{
   TStringList *keys = new TStringList();
   SaveToStrings(keys);
   keys->SaveToFile(FileName);
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::SaveToFileBak(AnsiString &FileName, int Bakcopies)
{
   if (Filename.IsEmpty()) return;
   TStringList *keys = new TStringList();
   SaveToStrings(keys);
 ::SaveToFileBak(keys,FileName,Bakcopies);
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList::DeleteKey(int AtPos)
{
   if (AtPos<0 || AtPos>=Count) return;
   delete dynamic_cast<TStringList*>(Objects[AtPos]);
   Delete(AtPos);
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList::EnabledDesc(AnsiString desc, TStrings *Type)
{
   bool enabled=true;
   AnsiString type; desc=CrtDesc(desc);
   for (int i=0; i<Type->Count; i++)
   {
      type = Type->Strings[i];
      if (type.SubString(1,1)!="#") continue;
      if ("#"+desc==type)
      {
         enabled = false;
         break;
      }
   }
   return enabled;
}
//---------------------------------------------------------------------------
// TMixKeyWin
//---------------------------------------------------------------------------
__fastcall TMixKeyWin::TMixKeyWin(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin::TMixKeyWin(TComponent* Owner, AnsiString KeyFile,
   AnsiString TypFile, AnsiString ListFile) : TForm(Owner)
{
   curkey = -1;
   keyring = KeyFile; typfile = TypFile;
   cap = Caption; Caption = "Loading...";
   SetHelpBtnPos();
   SetNothingSelected(); SaveBtn->Enabled = RefreshBtn->Enabled = false;
   AppProcessMessages();
   MixGenType2();
   keynode = new TList();
   keylist = new TMixKeyList(keyring);
   dislist = new TMixKeyList();
   typlist = new TStringList(); typlist->Sorted = true;
   if (FileExists(typfile)) typlist->LoadFromFile(typfile);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
 //SortDisabled(HideDisBox->Checked,keylist,dislist,typlist);
   keylist->GenTreeView(TreeView,typlist,keynode);
   checksave = true;
   typlistmod = false;
   modified = false;
   Caption = cap;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin::~TMixKeyWin()
{
   delete typlist;
   delete dislist;
   delete keylist;
   delete keynode;
   if (dynamic_cast<TMixProbWin*>(this)==NULL)
      MixKeyWin = NULL;
   SetCount(true); // clear status on exit
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::SetNothingSelected()
{
   RequestBtn->Enabled = false;
   DisableBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::OkBtnClick(TObject *Sender)
{
   checksave = false;
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::AddKeysImport(TMixKeyList *newkeys, bool keepprev)
{
   if (keepprev) keylist->newkeys->AddStrings(newkeys);
   else keylist->newkeys->Text = newkeys->Text;

   keylist->AddKeys(newkeys);
   MixGenType2(typlist,keylist);
   typlistmod = true;

   keylist->GenTreeView(TreeView,typlist,keynode);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::AddKeys(TMixKeyList *Newkeys)
{
   keylist->AddKeys(Newkeys);
   MixGenType2(typlist,keylist);
   typlistmod = true;

   keylist->GenTreeView(TreeView,typlist,keynode);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::AddRemailer(TStrings *AsciiBlock, bool enabled)
{
   if (!enabled && AsciiBlock->Count)
      typlist->Add("#"+CrtDesc(AsciiBlock->Strings[0]));
   keylist->ImportAscii(AsciiBlock->Text);

   TStringList *keys = new TStringList();
   keylist->SaveToStrings(keys);
   MixGenType2(typlist,keys);
   delete keys;

   keylist->GenTreeView(TreeView,typlist,keynode);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::GenTreeView()
{
   keylist->GenTreeView(TreeView,typlist,keynode);
   SetNothingSelected();
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::DeleteRemailer(int atPos)
{
   AnsiString line,desc=CrtDesc(KeyDesc(curkey));
   // delete from keyring
   delete dynamic_cast<TStringList*>(keylist->Objects[curkey]);
   keylist->Delete(curkey);
   // delete from type2.list
   for (int i=0; i<typlist->Count; i++)
   {
      line = TypDesc(i);
      if (desc==line || "#"+desc==line)
      {
         typlist->Delete(i);
         typlistmod = true;
         break;
      }
   }
   // regen treeview & exit
   keylist->GenTreeView(TreeView,typlist,keynode);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::DeleteBtnClick(TObject *Sender)
{
   AnsiString text=TreeView->Selected->Text,name=GetParam(0,text," ");
   if (MsgBoxHwnd(Handle,
     s("  You have asked to delete the mixmaster key for the remailer '"+name+"'.\n\n")+
     s("  I recommend that you NOT do that. If you delete the key QS will add\n")+
     s("  it again--if it is present in any downloaded keyring. Leaving it on the ring,  \n")+
     s("  but disabled, will prevent QS from adding or using the key in the future.\n\n")+
     s("  If you are sure this is a very old key and it is not present in any key\n")+
     s("  sources you may use, it is probably safe to delete the key. If you are\n")+
     s("  not sure, don't delete the key.\n\n")+
     s("  Delete this key?"),
     s("Confirm : delete key for "+name+" remailer"),
     MB_OKCANCEL)==IDOK)
   {
      DeleteRemailer(curkey);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "MixmasterKeys\nMixmasterKeysImp\nMixmasterKeysDup",
      "Mixmaster Key Manager",
      "Mixmaster Keyring Manager"
   );
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::SaveBtnClick(TObject *Sender)
{
   int bakcopies=STATSBAKCOPIES;
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   //if (typlistmod)
   SaveToFileBak(typlist,typfile,bakcopies);
   TStringList *keys = new TStringList();
   TStringList *diss = new TStringList(); // make sure and get disabled keys
   keylist->SaveToStrings(keys);
   dislist->SaveToStrings(diss);
   if (keys->Count && keys->Strings[keys->Count-1].IsEmpty()) keys->Add("");
   keys->AddStrings(diss);
   if (keys->Count)
      SaveToFileBak(keys,keyring,bakcopies);
   else if (FileExists(mringtxt))
      DeleteFile(s(mringtxt).c_str());
   keylist->newkeys->Clear();
   FlashCaption("Saving...",2);
   GenTreeView();
   if (MixProbWin && MixProbWin->keylist->newkeys->Count)
   {
      MixProbWin->keylist->newkeys->Clear();
      MixProbWin->GenTreeView();
      MixProbWin->Save();
   }
   typlistmod = false;
   modified = false;
   delete diss;
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TMixKeyList *impkeys = new TMixKeyList();
   TMixKeyList *dupkeys = new TMixKeyList();
   ImportDir = orgDir = GetAppIni(MixImportDir,MixDir());
   if (ImportMixmasterKeys(this,keylist,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         Sleep(150); SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
         AppProcessMessages(); SetRedraw(this,0); Sleep(150); SetRedraw(this,1);
         BringToFront();
         AddKeysImport(impkeys,false);
      }
      if (dupkeys->Count)
      {
         if (!MixProbWin) MixProbWin = new TMixProbWin(AppMainForm,false);
         AppProcessMessages()
         MixProbWin->BringToFront();
         MixProbWin->AddKeysImport(dupkeys,false);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::FormResize(TObject *Sender)
{
   //if (WindowState==wsMinimized) SetCount(true);
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (WindowState!=wsMinimized && !clear && keylist && keylist->Count)
   {
      cur = curkey>=0 ? s(curkey+1)+"/" : s("");
      count = cur+s(keylist->Count);
   }
   SendMessage(AppMainForm->Handle,WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::SetHelpBtnPos()
{
   HelpBtn->Left = Width-40;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   RequestBtn->Enabled = Node->Level==0;
   DisableBtn->Enabled = Node->Level==0;
   DeleteBtn->Enabled = Node->Level==0;
   curkey = Node->Index;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::PopupMenuPopup(TObject *Sender)
{
   if (TreeView->Selected && TreeView->Selected->Level==0)
   {
      PopDisableItem->Enabled = true;
      PopDisableItem->Checked = !keylist->EnabledDesc(KeyDesc(curkey),typlist);
   }
   PopShowDisabledItem->Checked = !dislist->Count;
   PopDeleteItem->Enabled = PopDisableItem->Enabled;
   PopSaveItem->Enabled = modified;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::RefreshBtnClick(TObject *Sender)
{
   if (modified && MsgBoxHwnd(Handle,
      s("Your keyring is modified. Refresh from disk will discard your changes?\n\n")+
      s("Refresh now?"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL) return;

   keylist->newkeys->Clear();
   Sleep(200);
   keynode->Clear();
   keylist->Clear();
   typlist->Clear();
   dislist->Clear();
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
   AppProcessMessages(); SetRedraw(this,0); Sleep(200);
   if (FileExists(keylist->Filename)) keylist->LoadFromFile(keylist->Filename);
   if (FileExists(typfile)) typlist->LoadFromFile(typfile);
   else MixGenType2(typlist,keylist,save);
   //SortDisabled(HideDisBox->Checked,keylist,dislist,typlist);
   keylist->GenTreeView(TreeView,typlist,keynode);
   RequestBtn->Enabled = false;
   DisableBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   SetRedraw(this,1);
   typlistmod = false;
   modified = false;
   SetCount();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyWin::CrtDesc(AnsiString &keydesc)
{
   return keylist->CrtDesc(keydesc);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyWin::KeyDesc(int atPos)
{
   return keylist->KeyDesc(atPos);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyWin::TypDesc(int atPos)
{
   if (atPos<0 || atPos>=typlist->Count) return "";
   return typlist->Strings[atPos]; //CrtDesc(typlist->Strings[atPos]);
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyWin::Enabled(int atPos)
{
   if (atPos<0 || atPos>=keylist->Count) return false;
   bool tmp=EnabledDesc(KeyDesc(atPos));
   return tmp;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyWin::EnabledDesc(AnsiString &keydesc)
{
   bool enabled=true;
   AnsiString type,desc=CrtDesc(keydesc);
   for (int i=0; i<typlist->Count; i++)
   {
      type = typlist->Strings[i];
      if (type.SubString(1,1)!="#") continue;
      if ("#"+desc==type)
      {
         enabled = false;
         break;
      }
   }
   return enabled;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::SortDisabled(bool hidedisabled, TMixKeyList *keylist,
   TMixKeyList *dislist, TStrings *typlist)
{
   if (hidedisabled)
   {
       int i=0; while (i<keylist->Count)
       {
          bool del=false;
          AnsiString keydesc=CrtDesc(KeyDesc(i));
          for (int t=0; t<typlist->Count; t++)
          {
             if ("#"+keydesc==CrtDesc(typlist->Strings[i]))
             {
                dislist->ImportAscii(keylist->ExportAscii(i));
                keylist->DeleteKey(i);
                del = true;
                break;
             }
          }
          if (!del) i++;
       }
   }
   else
   {
       for (int i=0; i<dislist->Count; i++)
       {
          keylist->ImportAscii(dislist->ExportAscii(i));
       }
       dislist->Clear();
   }
   SetCount();
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyWin::EnableKey(AnsiString &keydesc, bool Enable)
{
   return EnableKey(keylist->IndexOf(keydesc),Enable);
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyWin::EnableKey(int atPos, bool Enable)
{
   if (atPos<0 || atPos>=keylist->Count) return false;
   EnableTypeFile(atPos,Enable);
   EnableTreeView(atPos,Enable);
   GenTreeView();
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::EnableTypeFile(int atPos, bool enable)
{
   if (curkey>=0 && (atPos<0 || atPos>=keylist->Count)) return;

   typlist->Sorted = false;
   AnsiString type,desc=CrtDesc(KeyDesc(atPos));
   if (enable)
   {
      for (int i=0; i<typlist->Count; i++)
      {
         type = typlist->Strings[i];
         if (type.SubString(1,1)!="#") continue;

         if ("#"+desc==type)
         {
            typlist->Strings[i] = desc;
            typlistmod = true;
         }
      }
   }
   else
   {
      for (int i=0; i<typlist->Count; i++)
      {
         type = typlist->Strings[i];
         if (type.SubString(1,1)=="#") continue;

         if (desc==type)
         {
            typlist->Strings[i] = "#"+desc;
            typlistmod = true;
         }
      }
   }
   typlist->Sorted = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::EnableTreeView(int atPos, bool enable)
{
   if (curkey>=0 && (atPos<0 || atPos>=keylist->Count)) return;
   TTreeNode* node = (TTreeNode*)keynode->Items[atPos];
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::DisableBtnClick(TObject *Sender)
{
   RECT r = { 0,0,35,2000 };
   bool enable=Enabled(curkey);
   EnableTreeView(curkey,!enable);
   EnableTypeFile(curkey,!enable);
   InvalidateRect(TreeView->Handle,&r,false);
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall MakeMessage(TStrings *message, AnsiString &addrs, AnsiString &subject)
{
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   THeaderManager *Headers = new THeaderManager(msg);
   PutAppData(MailQueue+PS+Headers->IndexString(msg),msg);
   delete Headers;
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::RemailerConfigItemClick(TObject *Sender)
{
   TMenuItem *item=dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      AnsiString remaddrs,subject,TempName;
      if (TreeView->Selected) remaddrs = TreeView->Selected->Text;
      remaddrs = GetParam(1,remaddrs," "); if (remaddrs.IsEmpty()) return;
      TStringList *temps = new TStringList();
      GetAppData(temps,UserTemplates);
      if (temps->IndexOf("config-request")>=0) TempName = "config-request";
      if (TempName.IsEmpty()) TempName =
          GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
      if(!TempName.IsEmpty())
      {
         AnsiString cap = Caption; Caption = "Queueing message(s)...";
         TStringList *Template = new TStringList();
         GetAppData(Template,UserTemplates+PS+TempName);
         switch (item->Tag)
         {
            case 2:
               MakeMessage(Template,remaddrs,"remailer-config");
               break;
            case 3:
               MakeMessage(Template,remaddrs,"remailer-key"   );
               break;
            case 4:
               MakeMessage(Template,remaddrs,"remailer-help"  );
               break;
            case 5:
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
            default:
               MakeMessage(Template,remaddrs,"remailer-config");
               MakeMessage(Template,remaddrs,"remailer-key"   );
               MakeMessage(Template,remaddrs,"remailer-help"  );
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
         }
         AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
         AppMainForm->Perform(WM_SHOWSTATUS,0,
            (LPARAM)"Config-request(s) created and queued");
         delete Template;
         Sleep(200);
         Caption = cap;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified || SaveBtn->Enabled)
   {
      if (checksave)
      {
         switch(MsgBoxHwnd(Handle,"Your keyring is modified!  Save your changes?",
            "Confirm",MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose=false; return;
            case IDNO:
               if (MixProbWin)
               {
                  TMixKeyList *keylist=MixProbWin->keylist;
                  TStrings *newkeys=keylist->newkeys;
                  for (int i=0; i<newkeys->Count; i++)
                  {
                     int pos = keylist->IndexOf(newkeys->Strings[i]);
                     if (pos>=0) keylist->DeleteKey(pos);
                  }
                  MixProbWin->GenTreeView();
               }
               return;
         }
      }
      SaveBtn->Click();
   }
   if (MixProbWin && MixProbWin->keylist->newkeys->Count)
   {
      MixProbWin->keylist->newkeys->Clear();
      MixProbWin->GenTreeView();
      MixProbWin->Save();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::HideDisBoxClick(TObject *Sender)
{
   bool locked = LockWindowUpdate(Handle);
   //SortDisabled(HideDisBox->Checked,keylist,dislist,typlist);
   keylist->GenTreeView(TreeView,typlist,keynode);
   RequestBtn->Enabled = false;
   DisableBtn->Enabled = false;
   DeleteBtn->Enabled = false;
   curkey = -1;
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::TreeViewMouseDown(TObject *Sender,
  TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
 	 if (HitTest.Contains(htOnIcon))
      DisableBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::TreeViewDragOver(TObject *Sender, TObject *Source,
  int X, int Y, TDragState State, bool &Accept)
{
   if (dynamic_cast<TTreeView*>(Source)!=NULL) Accept = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::TreeViewDragDrop(TObject *Sender, TObject *Source,
  int X, int Y)
{
   if (MixProbWin)
   {
      TTreeView *src = dynamic_cast<TTreeView*>(Source);
      if (src)
      {
         TTreeNode *node = src->Selected;
         DropKeyImport((TStrings*)node->Data,node->ImageIndex==0);
         MixProbWin->DeleteRemailer(MixProbWin->curkey);
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::DropKeyImport(TStrings *AsciiKey, bool enabled)
{
   if (!AsciiKey) return;
   TMixKeyList *key = new TMixKeyList(AsciiKey); // only one key allowed
   if (!enabled && key->Count) typlist->Add("#"+key->CrtDesc(0));
      AddKeysImport(key,true);
   delete key;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::FormActivate(TObject *Sender)
{
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::PopupMenu2Popup(TObject *Sender)
{
   PubringItem->Enabled = FileExists(mringtxt);
   TypeListItem->Enabled = FileExists(mtyp2txt);
   ListDocItem->Enabled = FileExists(mlisttxt);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::FlashCaption(AnsiString &cap, int flashcount)
{
   flashcap = cap; flash = 0; flashes = flashcount;
   FlashTimer->Enabled = true;
   while (FlashTimer->Enabled) AppProcessMessages();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin::FlashTimerTimer(TObject *Sender)
{
   if (Caption.IsEmpty()) Caption = flashcap;
   else Caption = "";

   if (flash==flashes)
   {
      FlashTimer->Enabled = false;
      Caption = cap;
      return;
   }
   flash++;
}
//---------------------------------------------------------------------------
