//---------------------------------------------------------------------------
#ifndef MixKeyWinsH
#define MixKeyWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\Menus.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
void __fastcall SetTreeItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree);

class TMixKeyList : public TStringList
{
public:
   AnsiString Filename;
   TStringList *newkeys;
   virtual __fastcall TMixKeyList();
   virtual __fastcall TMixKeyList(AnsiString Filename);
   virtual __fastcall TMixKeyList(TStrings *keyblocks);
   virtual __fastcall~TMixKeyList();
   virtual int  __fastcall AddAscii(TStrings* keyblock);
   virtual bool __fastcall GetNextKey(AnsiString &keydesc,TStrings *key,TStrings *keys);
   virtual void __fastcall GenTreeView(TTreeView *TreeView, TStrings *type2,
      TList *keys);
   virtual AnsiString __fastcall ExportAscii(int atPos);
   virtual int  __fastcall ImportAscii(AnsiString AsciiStr);
   virtual int  __fastcall AddKey(AnsiString &keydesc, TStrings* keyblock);
   virtual int  __fastcall AddKeys(TMixKeyList *keys);
   //virtual int  __fastcall AddKeysImport(TMixKeyList *keys);
   virtual void __fastcall DeleteKey(int atPos);
   virtual void __fastcall SaveToStrings(TStrings *Strings);
   virtual void __fastcall LoadFromStrings(TStrings *Strings);
   virtual bool __fastcall KeyDescExists(AnsiString &keydesc);
   virtual void __fastcall LoadFromFile(AnsiString FileName);
   virtual bool __fastcall EnabledDesc(AnsiString desc, TStrings *type2);
   virtual AnsiString __fastcall CrtDesc(int atPos);
   virtual AnsiString __fastcall CrtDesc(AnsiString keydesc);
   virtual AnsiString __fastcall KeyDesc(int atPos);
   virtual AnsiString __fastcall KeyShort(int atPos);
   virtual int  __fastcall IndexOf(AnsiString Remailer);
   virtual void __fastcall SaveToFileBak(AnsiString &FileName, int bakcopies);
   virtual void __fastcall SaveToFile(AnsiString FileName);
   virtual void __fastcall Save(int bakcopies=0);
   virtual void __fastcall Clear();
};

class TMixKeyWin : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TBevel *Bevel5;
  TBevel *Bevel3;
  TBevel *Bevel2;
  TOfficeButton *DeleteBtn;
  TOfficeButton *HelpBtn;
  TOfficeButton *OkBtn;
  TOfficeButton *ImportBtn;
  TOfficeButton *SaveBtn;
  TOfficeButton *DocsBtn;
  TOfficeButton *RefreshBtn;
  TOfficeButton *DisableBtn;
  TOfficeButton *RequestBtn;
  TCheckBox *HideDisBox;
  TPopupMenu *PopupMenu1;
  TMenuItem *RemailerAlldocsItem;
  TMenuItem *N2;
  TMenuItem *RemailerConfigItem;
  TMenuItem *RemailerKeyItem;
  TMenuItem *RemailerHelpItem;
  TMenuItem *RemailerStatsItem;
  TPopupMenu *PopupMenu2;
  TPopupMenu *PopupMenu;
  TMenuItem *PopDisableItem;
  TMenuItem *PopShowDisabledItem;
  TMenuItem *N1;
  TMenuItem *PopSaveItem;
  TMenuItem *PopRefreshItem;
  TMenuItem *PopImportItem;
  TMenuItem *N3;
  TMenuItem *PopDeleteItem;
  TTreeView *TreeView;
  TMenuItem *PubringItem;
  TMenuItem *TypeListItem;
  TMenuItem *ListDocItem;
  TTimer *Timer1;
  TImageList *ImageList1;
  TBevel *Bevel1;
  TTimer *FlashTimer;
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall DeleteBtnClick(TObject *Sender);
  void __fastcall HelpBtnClick(TObject *Sender);
  void __fastcall SaveBtnClick(TObject *Sender);
  void __fastcall RemailerDocItemClick(TObject *Sender);
  void __fastcall ImportBtnClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
  void __fastcall PopupMenuPopup(TObject *Sender);
  void __fastcall RefreshBtnClick(TObject *Sender);
  void __fastcall DisableBtnClick(TObject *Sender);
  void __fastcall RemailerConfigItemClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HideDisBoxClick(TObject *Sender);
  void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
     TShiftState Shift, int X, int Y);
  void __fastcall TreeViewDragOver(TObject *Sender, TObject *Source, int X,
     int Y, TDragState State, bool &Accept);
  void __fastcall TreeViewDragDrop(TObject *Sender, TObject *Source, int X,
     int Y);
  void __fastcall FormActivate(TObject *Sender);
  void __fastcall PopupMenu2Popup(TObject *Sender);
  void __fastcall FlashTimerTimer(TObject *Sender);
private:	// User declarations
public:		// User declarations
  TList* keynode;
  TStringList *typlist;
  TMixKeyList *keylist;
  TMixKeyList *dislist;
  int curkey,flash,flashes;
  AnsiString flashcap,keyring,typfile,cap;
  bool modified,typlistmod,checksave;
  virtual __fastcall TMixKeyWin(TComponent* Owner); // unused
  virtual __fastcall TMixKeyWin(TComponent* Owner, AnsiString KeyFile, AnsiString TypFile,
     AnsiString ListFile="");
  virtual __fastcall ~TMixKeyWin();
  void __fastcall AddRemailer(TStrings *AsciiBlock, bool Enabled);// redraws screen after add
  void __fastcall AddKeys(TMixKeyList *newkeys);
  void __fastcall AddKeysImport(TMixKeyList *newkeys, bool keepprev);
  void __fastcall DropKeyImport(TStrings *AsciiKey, bool enabled);
  virtual void __fastcall SortDisabled(bool hidedisabled, TMixKeyList *keylist,
     TMixKeyList *dislist, TStrings *typlist);
  // enable/disable item
  virtual bool __fastcall Enabled(int atPos);
  virtual bool __fastcall EnabledDesc(AnsiString &desc);
  virtual void __fastcall EnableTypeFile(int atPos, bool enable);
  virtual void __fastcall EnableTreeView(int atPos, bool enable);
  virtual AnsiString __fastcall CrtDesc(AnsiString &keydesc);
  virtual AnsiString __fastcall KeyDesc(int atPos);
  virtual AnsiString __fastcall TypDesc(int atPos);
  virtual void __fastcall DeleteRemailer(int atPos);
  virtual void __fastcall SetNothingSelected();
  virtual void __fastcall SetHelpBtnPos();
  virtual void __fastcall GenTreeView();
  virtual void __fastcall SetCount(bool clear=false);
  void __fastcall FlashCaption(AnsiString &cap, int flashes=4);
  bool __fastcall EnableKey(AnsiString &keydesc, bool Enable);
  bool __fastcall EnableKey(int atPos, bool Enable);
};
//---------------------------------------------------------------------------
extern TMixKeyWin *MixKeyWin;
//---------------------------------------------------------------------------
#endif
