//---------------------------------------------------------------------------
#ifndef PgpTestBufsH
#define PgpTestBufsH
//---------------------------------------------------------------------------

typedef unsigned char byte;
typedef struct {
  byte *data;
  long length;
  long ptr;
  long size;
  byte sensitive;
} BUFFER;

static void fail(void);

BUFFER *buf_new();
int buf_rewind(BUFFER *buffer);
int buf_clear(BUFFER *buffer);
int buf_append(BUFFER *buffer, byte *to, int len);
int buf_get(BUFFER *buffer, BUFFER *to, int n);
void buf_ungetc(BUFFER *buffer);
int buf_geti(BUFFER *b);
int buf_appendi(BUFFER *b, int i);
int buf_cat(BUFFER *to, BUFFER *from);
int buf_reset(BUFFER *buffer);
int buf_free(BUFFER *buffer);
int buf_getc(BUFFER *buffer);
int buf_appendc(BUFFER *to, byte b);
long buf_getl(BUFFER *b);
int buf_appendl(BUFFER *b, long l);
int buf_appendl_lo(BUFFER *b, long l);
int buf_rest(BUFFER *to, BUFFER *from);
int buf_sets(BUFFER *buffer, char *s);
int buf_appends(BUFFER *buffer, char *s);
int buf_readfile(BUFFER *buffer, char *filename);
void buf_move(BUFFER *dest, BUFFER *src);
int buf_prepare(BUFFER *buffer, int size);

#define BUFFER_MAX 2*1024*1024
#define BUFSIZE 4096

#endif
