//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\inifiles.hpp>
#include <time.h>
#pragma hdrstop

#include "PgpTestDlgs.h"
#include "PgpTestPgp.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPgpTestDlg *PgpTestDlg;
//---------------------------------------------------------------------------
__fastcall TPgpTestDlg::TPgpTestDlg(TComponent* Owner)
	: TForm(Owner)
{
   Memo1->Clear();
   packets = new TStringList();
   packets->Duplicates = dupIgnore;
   TIniFile *ini = new TIniFile(ChangeFileExt(AppExeName,".ini"));
   ComboBox1->ItemIndex = ini->ReadInteger("main","lastfile",0);
   delete ini;

   hSSLLib = LoadLibrary("c:\\progra~1\\mixmaster\\libeay32.dll");
   //main = KeyList->Selected;

   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::CloseBtnClick(TObject *Sender)
{
   FreeLibrary(hSSLLib);
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::GenBinaryNumbers()
{
   char numstr[16];
   AnsiString dec,bin;
   for (int i=0; i<256; i++)
   {
      dec = i; while (dec.Length()<3) dec = " "+dec;
      bin = s(itoa(i,numstr,2));
      while (bin.Length()<8) bin = "0"+bin;
      Memo1->Lines->Add(" "+dec+"  "+bin+"  "+bin.SubString(3,4));
      Memo1->Lines->SaveToFile("c:\\windows\\desktop\\binary.txt");
   }
}
//---------------------------------------------------------------------------
AnsiString algostr(int num)
{
   AnsiString algo=s(num);
   switch (num)
   {
      case  0: algo += " (RSA)"; break;
      case  1: algo += " (ES_RSA)"; break;
      case  4: algo += " (DS/DSS)"; break;
      case 16: algo += " (E_ELG)"; break;
      case 17: algo += " (S_DSA)"; break;
      default: algo += " (UNDEFINED)";
   }
   return algo;
}
//---------------------------------------------------------------------------
AnsiString mdalgostr(int num)
{
   AnsiString algo=s(num);
   switch (num)
   {
      case  1: algo += " (MD5)"; break;
      default: algo += " (UNDEFINED)";
   }
   return algo;
}
//---------------------------------------------------------------------------
AnsiString pkalgostr(int num)
{
   AnsiString algo=s(num);
   switch (num)
   {
      case  1: algo += " (RSA)"; break;
      default: algo += " (UNDEFINED)";
   }
   return algo;
}
//---------------------------------------------------------------------------
AnsiString truststr(AnsiString &trust, AnsiString &context)
{
   if (context=="0110")
   {
   }
   return "";
}
//---------------------------------------------------------------------------
/* Format of public key certificate
*
*   Ofs  Len  Meaning
*   0    1    CTB for public key certificate
*   1    2    16-bit (or maybe 8-bit) length of packet
*   3	 1	  Version byte, may affect rest of fields that follow.
*                 (=2) for PGP versions <= 2.5
*                 (=3) for PGP versions >= 2.6
*   4    4    Timestamp of key creation
*   8    2    Validity period, in number of DAYS (0 means forever)
*   10	 1	  Algorithm byte for RSA (=1 for RSA).
*    		  	--Algorithm byte affects field definitions that follow.
*   ?    ?    MPI of RSA public modulus n
*   ?    ?    MPI of RSA public encryption exponent e
*
*/
bool __fastcall ParsePublicKeyPacket(BUFFER *packet, int *version,
   int *unixtime, int *valid, int *algo, AnsiString *idtext8,
   BUFFER *modulus, BUFFER *exponent)
{
   buf_rewind(packet);
   byte ctb=(byte)buf_getc(packet);
   if (BinaryByte(ctb,5,2)!="0110") return false;
   pgp_getsize(packet);

   long *ptr = &packet->ptr;
   if (version) *version = buf_getc(packet); else *ptr+=1;
   if (unixtime) *unixtime = buf_getl(packet); else *ptr+=4;
   if (valid) *valid = buf_getc(packet); else *ptr+=1;
   if (algo) *algo = buf_getc(packet); else *ptr+=1;

   BUFFER *dummy = buf_new();
   if (modulus) mpi_get(packet,modulus);
   else mpi_get(packet,dummy);
   if (exponent) mpi_get(packet,exponent);
   else mpi_get(packet,dummy);
   buf_free(dummy);

   if (idtext8) *idtext8 = pgp_getkeyidasc(packet);
   return true;
}
//---------------------------------------------------------------------------
/* Format of regular signature packets: v2, v3
*
*	Offset Length Meaning
*	0 1 Version byte (= 2 or 3).
*	1 1 x, Length of following material included in MD5 (=5)
*	2 1 Signature type (=0 or 1)
*	3 4 32-bit timestamp of signature
* -------- MD5 additional material stops here, at offset 2+x ---------
*	2+x	8	KeyID
*	10+x	1	PK algorithm type (1 = RSA)
*	11+x	1	MD algorithm type (1 = MD5)
*	12+x	2	First 2 bytes of message digest (16-bit checksum)
*	14+x	2+y	MPI of PK-encrypted integer
*	16+x+y
*/
bool __fastcall ParseSignaturePacket3(BUFFER *packet, int *version,
   int *implicit, int *sigclass, int *unixtime,
   AnsiString *idtext8, int *pkalgo,
   int *mdalgo, int *chksum)
{
   buf_rewind(packet);
   byte ctb=(byte)buf_getc(packet);
   if (BinaryByte(ctb,5,2)!="0010") return false;
   pgp_getsize(packet);

   long *ptr=&packet->ptr;
   if (version) *version = buf_getc(packet); else *ptr+=1;
   if (implicit) *implicit = buf_getc(packet); else *ptr+=1;
   if (sigclass) *sigclass = buf_getc(packet); else *ptr+=1;
   if (unixtime) *unixtime = buf_getl(packet); else *ptr+=4;
   if (idtext8) *idtext8 = pgp_getkeyidasc(packet); else ptr+=8;
   if (pkalgo) *pkalgo = buf_getc(packet); else *ptr+=1;
   if (mdalgo) *mdalgo = buf_getc(packet); else *ptr+=1;
   if (chksum) *chksum = buf_geti(packet); else *ptr+=2;

   return true;
}
//---------------------------------------------------------------------------
/* Format of one-pass signature packets:  v4
*
*	Offset Length Meaning
*	0	1	Version byte (=3)
*	1	1	Signature type
*	2	1	Hash Algorithm
*	3	1	PK Algorithm
*	4	8	KeyID
*	12	1	nested flag
*/
bool __fastcall ParseSignaturePacket4(BUFFER *packet, int *version,
   int *sigclass, int *hashalgo, int *pkalgo,
   AnsiString *idtext8, int *nestflag)
{
   buf_rewind(packet);
   byte ctb=(byte)buf_getc(packet);
   if (BinaryByte(ctb,5,2)!="0010") return false;
   pgp_getsize(packet);

   long *ptr=&packet->ptr;
   if (version) *version = buf_getc(packet); else ptr+=1;
   if (sigclass) *sigclass = buf_getc(packet); else ptr+=1;
   if (hashalgo) *hashalgo = buf_getc(packet); else ptr+=1;
   if (pkalgo) *pkalgo = buf_getc(packet); else ptr+=1;
   if (idtext8) *idtext8 = pgp_getkeyidasc(packet); else ptr+=8;
   if (nestflag) *nestflag = buf_getc(packet); else ptr+=1;

   return true;
}
//---------------------------------------------------------------------------
bool __fastcall ParseUserIdPacket(BUFFER *packet, AnsiString &userid)
{
   userid = (char*)&packet->data[2];
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall ParseCommentPacket(BUFFER *packet, AnsiString &comment)
{
   BUFFER *buf=buf_new();
   int len=buf_getc(packet);
   buf_get(packet,buf,len);
   comment = (char*)&buf->data[0];
   buf_free(buf);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall ParseTrustPacket(BUFFER *packet, AnsiString &trust)
{
   char binstr[16];
   int i = packet->data[2];
   AnsiString trs = itoa(i,binstr,2);
   trust = s("00000000").SubString(1,8-trs.Length())+trs;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall ParseLiteralDataPacket(BUFFER *packet,
   int &mode, AnsiString &filename, int &unixtime)
{
   buf_rewind(packet);
   byte ctb=(byte)buf_getc(packet);
   if (BinaryByte(ctb,5,2)!="1011") return false;

   pgp_getsize(packet);
   mode = buf_getc(packet);
   int len = buf_getc(packet);

   BUFFER *buf=buf_new();
   buf_get(packet,buf,len);
   filename = (char*)buf->data;
   delete buf;

   unixtime = buf_getl(packet);
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall ss(AnsiString &trust, int first,int len)
{
   return trust.SubString(first,len);
}
//---------------------------------------------------------------------------
AnsiString TrustStrs(AnsiString &trust, AnsiString &context)
{
   AnsiString str;
   if (context=="0110")
   {
      if (ss(trust,1,1)=="1")   str = "1-------  BUCKSTOP: ultimately trusted keyring owner |";
      else                      str = "0-------  Public key |";

      if (ss(trust,3,1)=="1")   str+= "--1-----  Disabled |";
      else                      str+= "--0-----  Enabled |";

      if (ss(trust,6,3)=="000") str+= "-----000  Undefined "; else
      if (ss(trust,6,3)=="001") str+= "-----001  We don't know the owner of this key"; else
      if (ss(trust,6,3)=="010") str+= "-----010  We usually do not trust this key owner to sign other keys "; else
      if (ss(trust,6,3)=="011") str+= "-----011  Reserved "; else
      if (ss(trust,6,3)=="100") str+= "-----100  Reserved "; else
      if (ss(trust,6,3)=="101") str+= "-----101  We usually do trust this key owner to sign other keys "; else
      if (ss(trust,6,3)=="110") str+= "-----110  We always trust this key owner to sign other keys "; else
      if (ss(trust,6,3)=="111") str+= "-----111  Also present on secret keyring ";
   }
   return str;
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::GrowTree()
{
   int pkversion;
   BUFFER *packet;
   bool gotid=false;
   AnsiString bin,context;
   TTreeNodes *Items=KeyList->Items;
   TTreeNode *node=NULL,*code,*dode,*main=KeyList->Selected;
   for (int i=0; i<packets->Count; i++)
   {
      bin = packets->Strings[i];
      packet = (BUFFER*)packets->Objects[i];
      pkversion=PacketVersion(packet);
      if (bin=="0110")
      {
         AnsiString timestamp,idtext8;
         int version,valid,algo,unixtime;

         ParsePublicKeyPacket(packet,&version,&unixtime,&valid,&algo,&idtext8,NULL,NULL);
         node = Items->AddChild(main,"Pub 0x"+idtext8+" ");
         code = Items->AddChild(node,bin+" Public Key Certificate");
         Items->AddChild(code,"Version    "+s(version));
         Items->AddChild(code,"TimeStamp  "+s(unixtime)+"  ("+TimeStamp(unixtime)+")");
         Items->AddChild(code,"Validity   "+s(valid));
         Items->AddChild(code,"Algorithm  "+algostr(algo));
         Items->AddChild(code,"Key Id     0x"+idtext8);
         context = bin;
         continue;
      }
      if (bin=="0010")
      {
         AnsiString timestamp,idtext8;
         int version,implicit,sigclass,unixtime,mdalgo,chksum,hashalgo,pkalgo,nestflag;

         code = Items->AddChild(node,bin+" Public-key-encrypted (signature) packet");
         switch (pkversion)
         {
            case 2:
            case 3:
               ParseSignaturePacket3(packet,&version,&implicit,&sigclass,&unixtime,&idtext8,
                  &pkalgo,&mdalgo,&chksum);
               Items->AddChild(code,"Version          "+s(version));
               Items->AddChild(code,"Implicit length  "+s(implicit));
               Items->AddChild(code,"Signature Class  "+s(sigclass));
               Items->AddChild(code,"TimeStamp        "+s(unixtime)+"  ("+TimeStamp(unixtime)+")");
               Items->AddChild(code,"Key Id           0x"+idtext8);
               Items->AddChild(code,"PK Algorithm     "+pkalgostr(pkalgo));
               Items->AddChild(code,"MD Algorithm     "+mdalgostr(mdalgo));
               Items->AddChild(code,"MD Checksum      "+s(chksum));
               break;
            case 4:
               ParseSignaturePacket4(packet,&version,&sigclass,&hashalgo,&pkalgo,&idtext8,
                  &nestflag);
               Items->AddChild(code,"Version          "+s(version));
               Items->AddChild(code,"Signature Class  "+s(sigclass));
               Items->AddChild(code,"Hash Algorithm   "+mdalgostr(pkalgo));
               Items->AddChild(code,"PK Algorithm     "+pkalgostr(mdalgo));
               Items->AddChild(code,"Key Id           0x"+idtext8);
               Items->AddChild(code,"Nested Flag      "+s(nestflag));
               break;
         }
         context = bin;
         continue;
      }
      if (bin=="1101")
      {
         AnsiString userid;
         ParseUserIdPacket(packet,userid);

         code = Items->AddChild(node,bin+" User Id");
         Items->AddChild(code,userid);
         if (!gotid)
         {
            node->Text = node->Text+userid;
            gotid = true;
         }
         context = bin;
         continue;
      }
      if (bin=="1100")
      {
         AnsiString trust,truststr,str;
         ParseTrustPacket(packet,trust);
         truststr = TrustStrs(trust,context);

         code = Items->AddChild(node,bin+" Trust Packet");
         dode = Items->AddChild(code,trust);
         int i=0; while ((str=GetToken(i++,truststr,"|"))!="")
            Items->AddChild(dode,str);
         continue;
      }
      if (bin=="1110")
      {
         AnsiString comment;
         ParseCommentPacket(packet,comment);

         code = Items->AddChild(node,bin+" Comment Packet");
         Items->AddChild(code,comment);
         continue;
      }
      //if (bin=="1011")
      //{
      //   ParseRawLiteralPacket(packet,mode,filename,unixtime,rawdata);
      //   5	1	mode byte, 'b'= binary or 't'= canonical text
      //   6	?	filename, with leading string length byte
	  //   4	Timestamp of last-modified date, or 0, or right now
	  //   ?	raw literal plaintext data
      //   bin += " Raw literal plaintext data, with filename and mode"; else
      //}

      code = Items->AddChild(node,bin+" Unknown Packet Type");
      Items->AddChild(code,"UNKNOWN, I said!");
   }
   // get rid of buffers in packets
   for (int i=0; i<packets->Count; i++)
      buf_free((BUFFER*)packets->Objects[i]);
   packets->Clear();
}

/* int i;
   char binstr[16];
   BUFFER *buf=buf_new(); buf_append(buf,data,len);
   AnsiString trs,bin = itoa(ctb,binstr,2);
   bin = bin.SubString(3,4);


   if (bin=="0010") bin += " secret-key-encrypted (signature) packet"; else
   if (bin=="0101") bin += " Secret key "+PgpKeyIdText8(buf); else
   if (bin=="1000") bin += " Compressed data packet"; else
   if (bin=="1001") bin += " Conventional-Key-Encrypted data"; else
*/
//---------------------------------------------------------------------------
bool buf_left(BUFFER *buf) // is there buf left to read
{
   return buf->ptr<buf->length;
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::ScanKeyring(AnsiString &Keyring)
{
   if (!FileExists(Keyring))
   {
      MsgBoxHwnd(Handle,
         "The file: "+Keyring+" does not exist!",
         "File Error",
          MB_OK
      );
   }
   AnsiString bin;
   packets->Clear();
   KeyList->Items->Clear();
   BUFFER *packet,*buf=buf_new();
   buf_readfile(buf,Keyring.c_str());
   while (true)
   {
      int ptr=buf->ptr;
      int ctb=buf_getc(buf);
      if (ctb<0)
      {
         if (!packets->Count) break;
         GrowTree();
         break;
      }

      AnsiString bin=BinaryByte((byte)ctb,5,2);
      if (packets->Count && (bin=="0110" || bin=="0101"))
         GrowTree();

      int lol=lolf((byte)ctb);
      int len=pgp_getsize(buf,(byte)ctb);

      buf->ptr = ptr;

      packet = buf_new();
      buf_get(buf,packet,len+lol+1);
      packets->AddObject(bin,(TObject*)packet);
   }
   buf_free(buf);
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::OkBtnClick(TObject *Sender)
{
   ScanKeyring(ComboBox1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   delete packets;
   TIniFile *ini = new TIniFile(ChangeFileExt(AppExeName,".ini"));
   ini->WriteInteger("main","lastfile",ComboBox1->ItemIndex);
   delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::ComboBox1Change(TObject *Sender)
{
   AnsiString keyring=ComboBox1->Text;
   if (!keyring.IsEmpty() && FileExists(keyring))
      ScanKeyring(keyring);
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   AnsiString keyring=ComboBox1->Text;
   if (!keyring.IsEmpty() && FileExists(keyring))
      ScanKeyring(keyring);
}
//---------------------------------------------------------------------------
void __fastcall TPgpTestDlg::ExpandBtnClick(TObject *Sender)
{
   if (ExpandBtn->Caption=="Expand")
   {
      ExpandBtn->Caption = "Collapse";
      KeyList->FullExpand();
      KeyList->TopItem = KeyList->Items->Item[0];
   }
   else
   {
      ExpandBtn->Caption = "Expand";
      KeyList->FullCollapse();
   }
}
//---------------------------------------------------------------------------
