//---------------------------------------------------------------------------
#ifndef PgpTestPgpH
#define PgpTestPgpH

#include "PgpTestBufs.h"
#include <time.h>

AnsiString TimeStamp(long unixtime);
AnsiString BinaryByte(byte value, byte frombit=7, byte tobit=0);
byte PacketVersion(BUFFER *packet);

int pgp_packet(BUFFER *in, int type);
int pgp_getpacket(BUFFER *in, BUFFER *p);
int pgp_packet(BUFFER *in, int type);
int pgpdb_getnext(BUFFER *keydb, BUFFER *key);
byte getCTB(TFileStream *f);

long pgp_getsize(BUFFER *buf, byte ctb=0); // 0 = rewind buffer

long lolf(BYTE CTB); // length-of-length field

AnsiString PgpKeyIdText8(BUFFER *key, int offset);
int PgpKeyId(BUFFER *key, int offset, BUFFER *keyid);

AnsiString pgp_getkeyidasc(BUFFER *key);
int pgp_getkeyid(BUFFER *packet, BUFFER *keyid);

int mpi_get(BUFFER *buf, BUFFER *mpi);
int mpi_put(BUFFER *buf, BUFFER *mpi);
int pgp_nummpi(int algo);
int digest_sha1(BUFFER *b, BUFFER *md);

#define ARMORED 1
// key type
#define PGP_PUBKEY 6
#define PGP_SECKEY 5
#define PGP_PUBSUBKEY 14
#define PGP_SECSUBKEY 7
#define PGP_USERID 13
#define PGP_COMMENT 14
#define PGP_SESKEY 1
// sigs
#define PGP_SIG 2
// algorithms
#define PGP_ANY 0
#define PGP_ES_RSA 1
#define PGP_E_ELG 16
#define PGP_S_DSA 17
// SHA
#define SHA_DIGEST_LENGTH 20
// SHA in libeay.dll
void __fastcall SHA1(byte *b, int n, byte* m);
typedef void (*_SHA1)(byte*, int, byte*);

#define space 128

extern HINSTANCE hSSLLib;
//---------------------------------------------------------------------------
#endif
