#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef RemailerDlgsH
#define RemailerDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Tabs.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Menus.hpp>
#include <HttpProt.hpp>

#include "MixKeyWins.h"
#include "global.h"
//---------------------------------------------------------------------------
bool  __fastcall GetRemailerStats(TForm *parent, bool attended=true);
bool __fastcall DocumentErrorChecking();

class TRemailerDoc : public TStringList
{
public:
   bool OpenDoc,Modified;
   virtual __fastcall TRemailerDoc();
   virtual __fastcall TRemailerDoc(AnsiString Docfile);
};

class TRemailerDlg : public TForm
{
__published:	// IDE-managed Components
 	 THttpCli *HttpCli1;
   TPanel *Panel2;
   TProgressBar *ProgressBar1;
  TButton *GetDocs;
   TButton *CancelBtn;
   TTimer *Timer1;
   TPanel *Panel1;
   TPageControl *PageControl1;
   TTabSheet *TabSheet1;
   TTabSheet *TabSheet3;
   TTabSet *TabSet;
   TLabel *Label1;
   TButton *OkBtn;
   TTabSheet *TabSheet4;
   TGroupBox *MixErrorGrp;
   TCheckBox *MixSyncTyp2Box;
   TCheckBox *MixRepNewBox;
   TCheckBox *MixUpdRingBox;
   TGroupBox *CpunkErrorGrp;
   TCheckBox *CpunkUpdRingBox;
   TCheckBox *CpunkErrorCheck;
   TCheckBox *MixErrorCheck;
   TCheckBox *CpunkRepNewBox;
   TCheckBox *MixListBox;
   TCheckBox *MixRingBox;
   TCheckBox *MixTyp2Box;
   TLabel *Label8;
   TCheckBox *CpunkListBox;
   TCheckBox *CpunkRingBox;
   TLabel *Label9;
   TLabel *Label10;
   TLabel *Label11;
   TLabel *Label12;
   TLabel *Label13;
   TButton *Button1;
   TCheckBox *CpunkSyncTyp1Box;
   TCheckBox *CpunkTyp1Box;
   TBitBtn *BitBtn2;
   TRichEdit *DocMemo;
   TRichEdit *RichEdit1;
   TButton *HelpBtn;
	 TTimer *TimeOutTimer;
   TTimer *Timer3;
  TPanel *Panel3;
  TGroupBox *MixmasterGrp;
  TCheckBox *MTyp2Box;
  TCheckBox *MRingBox;
  TCheckBox *MListBox;
  TComboBox *MListCBox;
  TComboBox *MRingCBox;
  TComboBox *MTyp2CBox;
  TGroupBox *CyberpunkGrp;
  TCheckBox *CRingBox;
  TCheckBox *CListBox;
  TCheckBox *CTyp1Box;
  TComboBox *CListCBox;
  TComboBox *CRingCBox;
  TButton *UrlsBtn;
  TCheckBox *ErrorCheck;
  TButton *OpenBtn;
  TButton *DeleteBtn;
  TButton *ProxyBtn;
	 void __fastcall GetDocsClick(TObject *Sender);
	 void __fastcall HttpCli1DocBegin(TObject *Sender);
	 void __fastcall HttpCli1DocEnd(TObject *Sender);
	 void __fastcall HttpCli1RequestDone(TObject *Sender, THttpRequest RqType, WORD Error);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len);
   void __fastcall CancelBtnClick(TObject *Sender);
   void __fastcall Timer1Timer(TObject *Sender);
   void __fastcall PageControl1Changing(TObject *Sender, bool &AllowChange);
   void __fastcall FormShow(TObject *Sender);
   void __fastcall UrlsBtnClick(TObject *Sender);
   void __fastcall TabSetChange(TObject *Sender, int NewTab, bool &AllowChange);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall ErrorCheckClick(TObject *Sender);
   void __fastcall CRingBoxClick(TObject *Sender);
   void __fastcall MRingBoxClick(TObject *Sender);
   void __fastcall HelpBtnClick(TObject *Sender);
   void __fastcall ProxyBtnClick(TObject *Sender);
   void __fastcall TimeOutTimerTimer(TObject *Sender);
   void __fastcall OpenRemailerDocClick(TObject *Sender);
   void __fastcall OpenBtnClick(TObject *Sender);
   void __fastcall DeleteBtnClick(TObject *Sender);
   void __fastcall Timer3Timer(TObject *Sender);

  
private:	// User declarations
public:		// User declarations
   int TimeOut,CurTime;
   TStrings *Tabs;
   AnsiString CurDoc;
   TCheckBox *CurBox;
   double BytesTotal;
   long BytesReceived;
   TStringList *mixnokey;
   TMixKeyList *mixkeys,*mixdups;
   TStringList *cpknokey;
   TMixKeyList *cpkkeys,*cpkdups;
   AnsiString Cap,Http,MListURL,MRingURL,MTyp2URL,CListURL,CRingURL;
   AnsiString ProxyHost,ProxyPort,ProxyPswd,ProxyUser;
   bool Attended,Cancelled,CancelAnyway,MixSelfUpdate,CpkSelfUpdate;
   __fastcall TRemailerDlg(TComponent* Owner);
   virtual __fastcall ~TRemailerDlg();
   void __fastcall LoadHttpInfo();
   void __fastcall StoreHttpInfo();
   bool __fastcall SaveStatistics();
   void __fastcall SaveErrChkLog(TRemailerDoc *Log);
   bool __fastcall Execute(bool attended);
   void __fastcall InitCheckmarks();
   void __fastcall GetAppURLs();
   void __fastcall LoadURLs();
   void __fastcall SetTabCurrent(AnsiString &TabName, TRemailerDoc *TabDoc);
   AnsiString __fastcall GetDefaultURL(AnsiString &path);
   bool __fastcall GetStatistics(AnsiString &forURL, TCheckBox *Box, AnsiString &Doc);
   bool __fastcall IsTab(int Index, AnsiString &TabName); // does Tab->Strings[index]==TabName
   void __fastcall SetTab(int TabIndex); // set tab's doc to docmemo text
   TRemailerDoc* __fastcall TabDoc(int Index); // if valid, tab's doc, else NULL
   void virtual  __fastcall SetDoc(AnsiString DocName, TRemailerDoc *Doc);
   void virtual  __fastcall SetDoc(int Index, TRemailerDoc *Doc);
   TRemailerDoc* __fastcall GetDoc(AnsiString DocName);
   TRemailerDoc* __fastcall GetDoc(int Index);
   bool __fastcall GetLastErrChkLog(TStrings *Log);
   void __fastcall SetDocMemo(TRemailerDoc *Doc, bool SaveCur=true);
   TRemailerDoc* __fastcall OpenRemailerDoc(AnsiString &Filename); // open doc for edit
   void __fastcall Display(AnsiString &text); // adds to end
   void __fastcall CheckDocumentsExist();
   void __fastcall ClearDocuments();
   void __fastcall GetBtnClick();
   void __fastcall ResetCheckboxes();
   int  __fastcall GoodTabs(); // tabcount of good, saveable docs
   // error checks
   void __fastcall ResetSelfUpdate();
   // error checks cpunk
   bool __fastcall CorruptDoc(TRemailerDoc *Doc);
   TRemailerDoc* __fastcall GetDocument(AnsiString &DocName);
   bool __fastcall CpkListOk(TRemailerDoc *doctxt);
   bool __fastcall CpkRingOk(TRemailerDoc *doctxt);
   bool __fastcall CpkListNewRemailer(TRemailerDoc *cpklist);
   bool __fastcall CpkKeysTooOld();
   // error checks mix
   bool __fastcall MixListOk(TRemailerDoc *doctxt);
   bool __fastcall MixRingOk(TRemailerDoc *doctxt);
   bool __fastcall MixListNewRemailer(TRemailerDoc *MixList);
   bool __fastcall MixKeysTooOld();
   // message map
   void virtual __fastcall WMGetButtonClick(TMessage& Msg);
   BEGIN_MESSAGE_MAP
   MESSAGE_HANDLER(WM_GETBUTTONCLICK,TMessage,WMGetButtonClick)
   END_MESSAGE_MAP(TForm)
};

//---------------------------------------------------------------------------
extern TRemailerDlg *RemailerDlg;
//---------------------------------------------------------------------------
#endif
